import { Paths } from "js-angusj-clipper/web";
import { Box2 } from "../Common/Box2";
import { NestFiler } from "../Common/Filer";
import { Part } from "./Part";
import { Path } from "./Path";
import { PlaceType } from "./PlaceType";
import { Point } from "../Common/Point";
/**
 * 排料零件的容器,用来放置零件
 * 它是一块大板
 * 也可以是一个网洞
 * 也可以是余料
 */
export declare class Container {
    protected BinPath?: Path;
    ParentId: number;
    ChildrenIndex: number;
    ParentM: Point;
    Placed: Part[];
    PlaceType: PlaceType;
    PlacedArea: number;
    PlacedBox: Box2;
    PlacedHull: Point[];
    StatusKey: string;
    constructor(BinPath?: Path);
    get UseRatio(): number;
    private _NotPuts;
    private PrePut;
    private Calc;
    PutPart(p: Part, greedy?: boolean): boolean;
    protected GetNFPs(part: Part, binNfp: Point[][]): Paths;
    /**
     * 将Part添加的Placed列表
     * @param part 零件,已经计算了放置状态
     * @param [calc=true] 是否计算当前的容器状态?
     */
    private AppendPart;
    /**
     * 得到最左边的点
     */
    protected GetFarLeftP(nfp: Point[][]): Point;
    ReadFile(file: NestFiler, parts: Part[]): this;
    WriteFile(file: NestFiler): void;
}
//# sourceMappingURL=Container.d.ts.map